Subject: Re: [clue] Maxcaptures in MCC, vs. switched and composed attributes

From: "Duckworth, Mark" <[email-masked]>
Date: Fri, 7 Feb 2014 08:26:53 -0800

I'm trying to summarize a couple of related proposals here.
1. Add ability for advertiser to indicate if the number of captures in an MCC at any given time will always be equal to MaxCaptures, or if it can be less. Details below from Christian.
2. Add Switched and Composed attributes to MCC, just like we used to have for all captures.  This is proposed in draft-ietf-clue-data-model-schema-03.  Maybe remove the MaxCaptures attribute if we add switched and composed.

We can do one or the other, or both, or neither.  Any of those choices is okay with me, I personally have no strong argument either way. I think others in the group have stronger preferences.  I think the default is to do neither, unless there is consensus to change.  Please continue the discussion so we can figure out if any change is needed in the framework and data model.

Regards,
Mark

> -----Original Message-----
> From: clue [mailto:[email-masked]] On Behalf Of Christian Groves
> Sent: Thursday, February 06, 2014 11:50 PM
> To: [email-masked]
> Subject: Re: [clue] Maxcaptures in MCC
> 
> Hello Mark,
> 
> To be more concrete here's the text I would propose for the framework:
> 
> 7.2.1.1. Maximum Number of Captures within a MCC
> 
>     The Maximum Number of Captures MCC attribute indicates the maximum
>     number of individual captures that may appear in a Capture Encoding
>     at a time. <<An Advertiser may indicate whether or not>>> the actual
> number at any given time can be less than
>     this maximum.  It may be used to derive how the Single Media
>     Captures within the MCC are composed / switched with regards to
>     space and time. <<If the Advertiser indicates that the number of captures
> is equal
>     to the maximum the Consumer MUST not choose a subset of captures
> from the MCC in a
>     Configure message.>>
> 
>     Max Captures MAY be set to one so that only content related to one
>     of the sources are shown in the MCC Capture Encoding at a time or
>     it may be set to any value up to the total number of Source Media
>     Captures in the MCC.
> 
>     If this attribute is not set then as default it is assumed that <<any numbers
> of sources>>
>     can appear concurrently in the Capture Encoding associated with the MCC.
> 
>     For example: The use of MaxCaptures equal to 1 on a MCC with three
>     Video Captures VC1, VC2 and VC3 would indicate that the Advertiser
>     in the capture encoding would switch  between VC1, VC2 or VC3 as
>     there may be only a maximum of one capture at a time.
> 
> Regards, Christian
> 
> On 7/02/2014 11:45 AM, Christian Groves wrote:
> > Hello Mark,
> >
> > My proposed improvement is to update the MaxCaptures parameter add
> the
> > possibility to indicate indicate that the value is "equal to" as well
> > as allowing the specification as per today "less than or equal to".
> >
> > Regards, Christian
> >
> > On 7/02/2014 3:55 AM, Duckworth, Mark wrote:
> >> Hi Christian,
> >>
> >> I think I understand the general idea you are getting at, but I don't
> >> understand specifically what you are proposing as an improvement.
> >> More comments inline.
> >>
> >> Mark
> >>
> >>> -----Original Message-----
> >>> From: clue [mailto:[email-masked]] On Behalf Of Christian
> >>> Groves
> >>> Sent: Wednesday, February 05, 2014 7:20 PM
> >>> To: [email-masked]
> >>> Subject: Re: [clue] Now Maxcaptures - Re: spatial information can't
> >>> describe video locations within composed MCC
> >>>
> >>> Hello Paul and Mark,
> >>>
> >>> The Max-captures attributes currently indicates the maximum number
> >>> of captures that appears in a MCC at any particular point in time.
> >>>
> >>> i.e. MCC(VC1,VC2,VC3),MaxCaptures=3
> >>> So a Consumer has to assume because this is a maximum that VC1, VC2,
> >>> VC3, (VC1,VC2), (VC1,VC3), (VC2,VC3) or (VC1,VC2,VC3) can appear at
> >>> any point in time.
> >> [Duckworth, Mark] I agree, that is consistent with framework-13.
> >>
> >>> However the Consumer only ever sends a composition of
> (VC1,VC2,VC3).
> >>> It is
> >>> never going to change that combination.
> >> [Duckworth, Mark] Do you mean the Provider will always send a
> >> composition of (VC1,VC2,VC3)?  And the provider would like to be more
> >> explicit about this in the advertisement?
> >>
> >>> It seems to me that in this case
> >>> using MaxCaptures as it is currently defined is semantically incorrect.
> >> [Duckworth, Mark] I think it is correct, but maybe not giving as much
> >> information as the provider wants to express.
> > [CNG] I can't see its correct. If I tell you that I can do a set of
> > behaviour but I only intend to do one then I don't think that's
> > truthful. Sort of like telling you I'm coming to your house one day
> > next week when in fact I only intend on coming on Friday.
> >>
> >>> So what I am suggesting is simply to add a way to correctly indicate
> >>> this "constant number of captures" case, i.e. (VC1,VC2,VC3).
> >> [Duckworth, Mark] If I understand your suggestion correctly, then one
> >> way to do that would be to add a new optional MinCaptures attribute
> >> to an MCC.  MinCaptures is the minimum number of constituent captures
> >> that may appear in the MCC at a time.  If this attribute is not set,
> >> then it is assumed to have the default value of 1.  For this
> >> scenario, the value of both MinCaptures and MaxCaptures would be 3.
> >> Is this what you are suggesting, or do you have something else in mind?
> > [CNG] No all I had in mind was something like:
> >         MaxCaptures "="/"<=" value
> >       The Advertiser would chose to indicate "equal" or "equal to or
> > less than".
> >>> I think Paul is questioning the attribute in general. I do believe
> >>> that knowing the number of sources may be beneficial for a consumer
> >>> in deciding which MCC/Captures to select. There may be tradeoffs vs
> >>> a MCC only showing a limited number (i.e. one source) at a time vs
> >>> another MCC showing multiple sources at a time.
> > [CNG] I agree I think its beneficial.
> >>>
> >>> Regards, Christian
> >
> > _______________________________________________
> > clue mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/clue
> >
> 
> _______________________________________________
> clue mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/clue

---

From: Christian Groves <[email-masked]>
Date: Mon, 10 Feb 2014 12:15:45 +1100

Hello

I don't think removal of MaxCaptures is an option. I gave an example to 
Paul why its needed. It was buried deep in an email thread so i'll 
repeat it here:

I see there is benefit in giving the Advertiser and the Consumer the 
means of knowing how many captures will appear in the stream at a time. 
It gives the ability for the Consumer to distinguish between MCCs.

For example:
What if the Advertiser combines two sources set but switches the 
sources? i.e.
     MCC1(VC1, VC2, VC3, VC4, VC5, VC6, VC7, VC8),MaxCaptures=2
Are both the "switched" and "composed" attributes valid?
     MCC1(VC1, VC2, VC3, VC4, VC5, VC6, VC7, VC8),Switched,Composed

How about the case where the Advertiser composes 4 sources into a media 
stream switches those sources?
     MCC2(VC1, VC2, VC3, VC4, VC5, VC6, VC7, VC8),MaxCaptures=4
Using the composed and switched attributes:
     MCC2(VC1, VC2, VC3, VC4, VC5, VC6, VC7, VC8),Switched,Composed

Now how does a consumer distinguish between MCC1, MCC2 in this case? I 
think its a valid decision for a Consumer to make it determine how many 
sources it wants to see at a particular time. It can't use the spatial 
information because we've disallowed that. I don't think the "switched" 
and "composed" attributes can model that.

Regards, Christian

---

From: "Duckworth, Mark" <[email-masked]>
Date: Wed, 19 Feb 2014 13:12:01 -0800

We discussed this at the Feb 11 design team meeting but didn't come to any conclusion, either about the switched and composed attributes, or about the "=" and "<=" qualifier for maxCaptures.  I can't find minutes of the meeting, so I'm going by my memory here.

I still think the default is to make no changes unless there is stronger support from the group for a change.

Jonathan said he wanted to know more about how/why Christian's proposed "<=" qualifier for the maxCaptures attribute would be used.

In comparing the maxCaptures attribute to the composed and switched attributes, we thought the usefulness of composed and switched was for the case when both are true.  It doesn't have to be just one or the other.  There could be switching within a composition.  If the advertisement has an MCC without specifying constituent captures, and maxCaptures > 1, there is no way to tell if the provider will do switching (if we don't add the switched attribute).  We could add the switched attribute to allow the provider to express this.

Mark

> Sent: Sunday, February 09, 2014 8:16 PM
> To: [email-masked]
> Subject: Re: [clue] Maxcaptures in MCC, vs. switched and composed
> attributes
> 
> Hello
> 
> I don't think removal of MaxCaptures is an option. I gave an example to Paul
> why its needed. It was buried deep in an email thread so i'll repeat it here:
> 
> I see there is benefit in giving the Advertiser and the Consumer the means of
> knowing how many captures will appear in the stream at a time.
> What if the Advertiser combines two sources set but switches the sources?
> i.e.
>      MCC1(VC1, VC2, VC3, VC4, VC5, VC6, VC7, VC8),MaxCaptures=2 Are both
> the "switched" and "composed" attributes valid?
>      MCC2(VC1, VC2, VC3, VC4, VC5, VC6, VC7, VC8),MaxCaptures=4 Using the
> composed and switched attributes:
> sources it wants to see at a particular time. It can't use the spatial information
> because we've disallowed that. I don't think the "switched"
> > 1. Add ability for advertiser to indicate if the number of captures in an MCC
> at any given time will always be equal to MaxCaptures, or if it can be less.
> Details below from Christian.
> > 2. Add Switched and Composed attributes to MCC, just like we used to
> have for all captures.  This is proposed in draft-ietf-clue-data-model-schema-
> 03.  Maybe remove the MaxCaptures attribute if we add switched and
> composed.
> >
> > We can do one or the other, or both, or neither.  Any of those choices is
> okay with me, I personally have no strong argument either way. I think
> others in the group have stronger preferences.  I think the default is to do
> neither, unless there is consensus to change.  Please continue the discussion
> so we can figure out if any change is needed in the framework and data
> model.
> >
> > Regards,
> > Mark
> >
> >>      at a time. <<An Advertiser may indicate whether or not>>> the
> >> actual number at any given time can be less than
> >>      space and time. <<If the Advertiser indicates that the number of
> >> captures is equal
> >>      If this attribute is not set then as default it is assumed that
> >> <<any numbers of sources>>
> >>> possibility to indicate indicate that the value is "equal to" as
> >>> well as allowing the specification as per today "less than or equal to".
> >>>
> >>> Regards, Christian
> >>>
> >>>> I think I understand the general idea you are getting at, but I
> >>>> don't understand specifically what you are proposing as an
> improvement.
> >>>> More comments inline.
> >>>>
> >>>> Mark
> >>>>
> >>>>> Subject: Re: [clue] Now Maxcaptures - Re: spatial information
> >>>>> can't describe video locations within composed MCC
> >>>>>
> >>>>> Hello Paul and Mark,
> >>>>>
> >>>>> i.e. MCC(VC1,VC2,VC3),MaxCaptures=3 So a Consumer has to assume
> >>>>> because this is a maximum that VC1, VC2, VC3, (VC1,VC2),
> >>>>> (VC1,VC3), (VC2,VC3) or (VC1,VC2,VC3) can appear at any point in
> >>>>> time.
> >>>> composition of (VC1,VC2,VC3)?  And the provider would like to be
> >>>> more explicit about this in the advertisement?
> >>>>
> >>>> [Duckworth, Mark] I think it is correct, but maybe not giving as
> >>>> much information as the provider wants to express.
> >>>>> So what I am suggesting is simply to add a way to correctly
> >>>>> indicate this "constant number of captures" case, i.e. (VC1,VC2,VC3).
> >>>> [Duckworth, Mark] If I understand your suggestion correctly, then
> >>>> one way to do that would be to add a new optional MinCaptures
> >>>> attribute to an MCC.  MinCaptures is the minimum number of
> >>>> constituent captures that may appear in the MCC at a time.  If this
> >>>> attribute is not set, then it is assumed to have the default value
> >>>> of 1.  For this scenario, the value of both MinCaptures and
> MaxCaptures would be 3.
> >>>        The Advertiser would chose to indicate "equal" or "equal to
> >>> or less than".
> >>>>> that knowing the number of sources may be beneficial for a
> >>>>> consumer in deciding which MCC/Captures to select. There may be
> >>>>> tradeoffs vs a MCC only showing a limited number (i.e. one source)
> >>>>> at a time vs another MCC showing multiple sources at a time.

---

From: Christian Groves <[email-masked]>
Date: Thu, 20 Feb 2014 11:03:09 +1100

Hello Mark,

Just to clarify for maxCaptures the "<=" qualifier is essentially what 
is already in the draft today. Its the "=" that I'm proposing to add. 
Did Jonathon what the clarification on the existing qualifier or the 
additional one?

Here's the cases:

1) MCC1(VC1,VC2,VC3,VC4),MaxCaptures<=1
This is the switched case. Zero or 1 capture may be switched into the 
media stream. Note: zero is allowed because of the "<=".

2) MCC1(VC1,VC2,VC3,VC4),MaxCaptures=1
This is the switched case. Only 1 capture may be switched into the media 
stream.

3) MCC1(VC1,VC2,VC3,VC4),MaxCaptures<=2
This is a switched and composition case. The sources may be purely 
switched (i.e. <=2 allows for 1 source on its own), or they may be 
composed and switched (i.e. a composition of 2 sources switched between 
the 4 sources.

4) MCC1(VC1,VC2,VC3,VC4),MaxCaptures=2
This is a switched and composition case. The sources are composed and 
switched (i.e. a composition of 2 sources switched between the 4 
sources. Its not possible to have a single source.

5) MCC1(VC1,VC2,VC3,VC4),MaxCaptures<=4
This is a switched and composition case. As per 3 above, however there 
may be additional compositions of 3 and 4 sources.

6) MCC1(VC1,VC2,VC3,VC4),MaxCaptures=4
This is a composition case. All 4 sources are contained in the media 
stream. No switching.

As I mentioned below having MaxCapture is essential for choosing MCCs 
when different "compositions" or "switches" are on offer.

With respect to "switched" and "composed" I think there's interaction 
issues that would need to be considered if both MaxCaptures and 
"switched"/"composed" were both used.
i.e. what would MCC1(VC1,VC2,VC3,VC4),MaxCaptures=4,switched mean?

With regards to the empty MCC case the use of an "MCC" was to indicate 
that switching and/or composition was taking place for the capture? I 
would think if no information was being offered about the sources that 
this would be sufficient? The very use of MCC indicates the number of 
sources captures > 1. So if you used MaxCaptures=1 for MCC() it would 
indicate the switched case.

If people do see a need to indicate "composed" for an empty MCC perhaps 
we could look at another solution and reserve a MaxCaptures value to 
indicate this cases? or allow the MCC to contain a "number of sources" 
attribute which could be used when it doesn't want to specify the actual 
sources. This would avoid interaction problems between attributes.

Regards, Christian

---

From: Paul Kyzivat <[email-masked]>
Date: Thu, 20 Feb 2014 14:15:48 -0500

> Paul why its needed. It was buried deep in an email thread so i'll

We are all still trying to figure this out.
Maybe it will be easier when we are all in one place.

> It gives the ability for the Consumer to distinguish between MCCs.

An admirable goal.

>      MCC1(VC1, VC2, VC3, VC4, VC5, VC6, VC7, VC8),Switched,Composed

I think so.

> and "composed" attributes can model that.

When you use "maxcaptures=" this makes sense to me.

When you use "maxcaptures<=" then it gets harder. Certainly it is 
*possible* that the advertisement would use "maxcaptures<=4" but in 
reality never compose more than two. (It seems silly to do that, but how 
do we write a definition that calls for sensible behavior?)

A problem with "maxcaptures=" is that it can be rendered invalid by the 
consumer based on what it configures. E.g., for an advertisement containing:

The configure might have:

    MCC2(VC1, VC2, VC3)

Then it is impossible for the advertiser to include 4 captures.

At least *this* can probably be addressed using careful wording - that 
the "maxcaptures=" will be honored if the number of sources configured 
allows it to be.

	Thanks,
	Paul

>> 1. Add ability for advertiser to indicate if the number of captures in
>> an MCC at any given time will always be equal to MaxCaptures, or if it
>> can be less. Details below from Christian.
>> have for all captures.  This is proposed in
>> draft-ietf-clue-data-model-schema-03.  Maybe remove the MaxCaptures
>> attribute if we add switched and composed.
>>
>> We can do one or the other, or both, or neither.  Any of those choices
>> is okay with me, I personally have no strong argument either way. I
>> think others in the group have stronger preferences.  I think the
>> default is to do neither, unless there is consensus to change.  Please
>> continue the discussion so we can figure out if any change is needed
>> in the framework and data model.
>>
>> Regards,
>> Mark
>>
>>> actual
>>> captures

---

From: Christian Groves <[email-masked]>
Date: Fri, 21 Feb 2014 16:33:33 +1100

Hello Paul,

Please see below.

Regards, Christian

On 21/02/2014 6:15 AM, Paul Kyzivat wrote:
> When you use "maxcaptures<=" then it gets harder. 
[CNG] I think its applicable even for "MaxCaptures<=" because the 
maximum number of composed sources changes.

> Certainly it is *possible* that the advertisement would use 
> "maxcaptures<=4" but in reality never compose more than two. (It seems 
> silly to do that, but how do we write a definition that calls for 
> sensible behavior?)
[CNG] Yes this is the problem. It could advertise "maxcaptures<=4" and 
never compose more than two but that's not what the consumer would expect.
>
> A problem with "maxcaptures=" is that it can be rendered invalid by 
> the consumer based on what it configures. E.g., for an advertisement 
> containing:
>
[CNG] I agree we need to provide some guidance around this so that a 
consumer doesn't violate the maxcaptures when it chooses source captures.

>>>>>> don't
>>>>>> more
>>>>>> much
>>>>>>> indicate
>>>>>> one